//-----------------------------------------------------------------------
// Transistor Gijutsu  
// Sample C code to communicate with the Atmel AT24Cxx EEROM  
// via the I2C interface(I2CHW).    
//
// P1[5]:I2Cm_SDA:Pull Up To Vdd(2.7k[Ohm])
// P1[7]:I2Cm_SCL:Pull Up To Vdd(2.7k[Ohm])
//   
// This code runs as MultiMaster, then sends incremental data and receive   
// datas.    
// The address of the AT24Cxx is 0x50(You can edit by changing A0 and A1 pin).
//
// This source code is evaluation only
//----------------------------------------------------------------------- 

#include <m8c.h>
#include "PSoCAPI.h" 

unsigned char Send_Buffer[14] = {0x00,
								 0x00,
								 0x50, //P
								 0x53, //S
								 0x6F, //o
								 0x43, //C
								 0x20, // 
								 0x4D, //M
								 0x61, //a
								 0x73, //s
								 0x74, //t
								 0x65, //e
								 0x72, //r
								 0x30};//0

unsigned char Address_Buffer[2] = {0x00,0x00};
unsigned int  counter = 0;
unsigned char slave_address = 0x50;

void main()
{
	M8C_EnableGInt;
	I2CHW_Start();
	I2CHW_EnableMstr();
	I2CHW_EnableInt();
	LCD_Start();
	LCD_Init();
	LCD_Position(0,0);
	LCD_PrCString("send:");
	while(1)
	{	
		//For Evaluation
        while(!(PRT0DR & 0b00000001));
        I2CHW_bWriteBytes(slave_address, Send_Buffer, 14, I2CHW_CompleteXfer);  
        while(!I2CHW_bReadI2CStatus() & I2CHW_WR_COMPLETE);     
        I2CHW_ClrWrStatus();  
 		counter +=1;
		LCD_Position(0,7);
		LCD_PrHexInt(counter);
		
		
	}
}