//*****************************************************************************
//*****************************************************************************
//  FILENAME: I2CHWMstr.h
//   Version: 1.5, Updated on 2006/06/06 at 13:39:08
//  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
//
//  DESCRIPTION: UMName User Module C Language interface file
//               for the 22/24/26/27/29/42xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2006. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

// Create pragmas to support proper argument and return value passing
#pragma fastcall16  I2CHW_fReadBytes
#pragma fastcall16  I2CHW_bWriteBytes
#pragma fastcall16  I2CHW_bWriteCBytes
#pragma fastcall16  I2CHW_fSendStart
#pragma fastcall16  I2CHW_fSendRepeatStart
#pragma fastcall16  I2CHW_SendStop
#pragma fastcall16  I2CHW_fWrite
#pragma fastcall16  I2CHW_bRead

//-------------------------------------------------
// Prototypes of the I2CHW API.
//-------------------------------------------------
// High level commands
// Read bCnt bytes of data from slave at bSlaveAddr using mode bMode, place data (UCHAR) pbXferData[]
extern void  I2CHW_fReadBytes(BYTE bSlaveAddr, BYTE * pbXferData, BYTE bCnt, BYTE bMode);
// Read bCnt bytes of data from slave at bSlaveAddr using mode bMode, write data from (UCHAR) pbXferData[]
extern void  I2CHW_bWriteBytes(BYTE bSlaveAddr, BYTE * pbXferData, BYTE bCnt, BYTE bMode);
// Read bCnt bytes of data from slave at bSlaveAddr using mode bMode, write data from (const UCHAR) pbXferData[]
extern void  I2CHW_bWriteCBytes(BYTE bSlaveAddr, const BYTE * pcbXferData, BYTE bCnt, BYTE bMode);

// Low level commands
extern BYTE  I2CHW_fSendStart(BYTE bSlaveAddr, BYTE fRW);
extern BYTE  I2CHW_fSendRepeatStart(BYTE bSlaveAddr, BYTE fRW);
extern void  I2CHW_SendStop(void);
extern BYTE  I2CHW_fWrite(BYTE bData);
extern BYTE  I2CHW_bRead(BYTE fACK);

//-------------------------------------------------
// Status variables for I2CHW API's.
//-------------------------------------------------
extern char I2CHW_bStatus;
extern char I2CHW_RsrcStatus;

//
//export only the count values used in the i/o processing routine
//


#define I2CHW_READ_BUFTYPE                   0x0
#define I2CHW_READ_FLASH                     I2CHW_READ_BUFTYPE & 0x01

extern unsigned char     I2CHW_Write_Count;

#if (I2CHW_READ_BUFTYPE)
extern unsigned int    I2CHW_Read_CountHI;

#endif
extern unsigned char    I2CHW_Read_Count;


//-------------------------------------------------
// Constants for I2CHW API's.
//-------------------------------------------------
#define I2CHW_CompleteXfer   0x00 // Perform a complete I2C transfer
#define I2CHW_RepStart       0x01 // Perform a complete transfer with a Repeat Start
#define I2CHW_NoStop         0x02 // Perform a complete transfer, but leave off the stop

#define I2CHW_READ           0x01 // Set the R/W flag after the slave address.
#define I2CHW_WRITE          0x00 // Clear the R/W flag after the slave address.

#define I2CHW_XFER_ERROR     0x00 // Communication error with the slave.
#define I2CHW_NAKslave       0x00 // NAK the slave after a read.
#define I2CHW_ACKslave       0x01 // ACK the slave after a read.

// end of file I2CHWMstr.h

