//-----------------------------------------------------------------------  
// Sample C code to communicate with the Maxim/Dallas DS1307 clock/EEROM  
// via the I2C interface(I2Cm).    
//
// P1[6]:I2Cm_SCL:Pull Up To Vdd(2.7k[Ohm])
// P1[4]:I2Cm_SDA:Pull Up To Vdd(2.7k[Ohm])
//       
// The address of the DS1307 is 0x68.
//
//
// This source code is evaluation only
//-----------------------------------------------------------------------  
#include <m8c.h>        // part specific constants and macros  
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules

/*Set This Area By User... You can use other RTCs*/


unsigned char RTC_address = 0x68;
  
BYTE RTC_Receive_Buf[8];

const BYTE RTC_Write_Buf[9] = {0b00000000, //sub_address,
						 	   0b00000000, //second,
						 	   0b00000000, //minute,
						 	   0b00010010, //hour,
                         	   0b00000001, //day_of_week,
                         	   0b00000100, //day,
                         	   0b00000111, //month,
                         	   0b00001000, //year,
                         	   0b10010000};//control	       

const	char*	Day_Of_Week[] = {"Sun","Mon","Tue","Wed","Thr","Fri","Sat"};
   
void main()  
{  
    BYTE status = 0;  
    unsigned char i; 
    LCD_Start();
    I2Cm_Start();
    while(!status)
    { 
    	status = I2Cm_bWriteCBytes(RTC_address,RTC_Write_Buf,9,I2Cm_CompleteXfer);
    }  
    while(1)
    {
    	I2Cm_bWriteCBytes(RTC_address,RTC_Write_Buf,1,I2Cm_NoStop );   
        status = I2Cm_fReadBytes(RTC_address,RTC_Receive_Buf,7,I2Cm_RepStart );
        I2Cm_SendStop(); 
        LCD_Position(0,0);
		LCD_PrHexByte(RTC_Receive_Buf[2]); //second
		LCD_PrCString(":");
        LCD_PrHexByte(RTC_Receive_Buf[1]); //minute
		LCD_PrCString(":");
        LCD_PrHexByte(RTC_Receive_Buf[0]); //hour
		LCD_PrCString(":");
		LCD_Position(1,0);
		LCD_PrHexByte(RTC_Receive_Buf[6]); //second
		LCD_PrCString(":");
        LCD_PrHexByte(RTC_Receive_Buf[5]); //minute
		LCD_PrCString(":");
        LCD_PrHexByte(RTC_Receive_Buf[4]); //hour
        LCD_PrCString(":");
        LCD_PrCString(Day_Of_Week[(RTC_Receive_Buf[3])]); //hour
            
        if(!status) 
        {  
        	LCD_Init();
        	LCD_Position(0,0);
        	LCD_PrCString("Fail!");  
        }
                               
    } 
}   
