//-----------------------------------------------------------------------  
// Sample C code to communicate with the RTC8564 clock  
// via the I2C interface(I2Cm).    
//
// P1[6]:I2Cm_SCL:Pull Up To Vdd(2.7k[Ohm])
// P1[4]:I2Cm_SDA:Pull Up To Vdd(2.7k[Ohm])
//   
//
//
// This source code is evaluation only
//-----------------------------------------------------------------------  
#include <m8c.h>        // part specific constants and macros  
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules

/*Set This Area By User... You can use other RTCs*/


unsigned char RTC_address = 0b01010001;
  
BYTE RTC_Receive_Buf[16];

const BYTE RTC_Write_Buf[17] = {0b00000000, // :sub_address,
                                0b00000000, //0:control_register1
                                0b00000000, //1:control_register2
						 	    0b00000000, //2:second,
						 	    0b00000000, //3:minute,
						 	    0b00010010, //4:hour,
                         	    0b00000001, //5:day,
                         	    0b00000001, //6:day_of_the_week,
                         	    0b00000111, //7:month,
                         	    0b00001000, //8:year
                         	    0b10000000, //9:minute alarm
                         	    0b10000000, //A:hour alarm
                         	    0b10000000, //B:day alarm
                         	    0b10000000, //C:day of the week alarm
                         	    0b10000011, //D:clkout 1Hz
                         	    0b00000000, //E:timer control
                         	    0b00000000};//F:timer
       

const	char*	Day_Of_Week[] = {"Sun","Mon","Tue","Wed","Thr","Fri","Sat"};
   
void main()  
{  
    BYTE status = 0;  
    unsigned char i; 
    LCD_Start();
    I2Cm_Start();
    while(!status)
    { 
    	status = I2Cm_bWriteCBytes(RTC_address,RTC_Write_Buf,17,I2Cm_CompleteXfer);
    }  
    while(1)
    {
    	I2Cm_bWriteCBytes(RTC_address,RTC_Write_Buf,1,I2Cm_NoStop );   
        status = I2Cm_fReadBytes(RTC_address,RTC_Receive_Buf,9,I2Cm_RepStart );
        I2Cm_SendStop(); 
        LCD_Position(0,0);
		LCD_PrHexByte(RTC_Receive_Buf[4]&0b00111111); //hour
		LCD_PrCString(":");
        LCD_PrHexByte(RTC_Receive_Buf[3]&0b01111111); //minute
		LCD_PrCString(":");
        LCD_PrHexByte(RTC_Receive_Buf[2]&0b01111111); //second
		LCD_PrCString(":");
		LCD_Position(1,0);
		LCD_PrHexByte(RTC_Receive_Buf[8]&0b11111111); //year
		LCD_PrCString("/");
        LCD_PrHexByte(RTC_Receive_Buf[7]&0b00011111); //month
		LCD_PrCString("/");
        LCD_PrHexByte(RTC_Receive_Buf[5]&0b00111111); //day
        LCD_PrCString("/");
        LCD_PrCString(Day_Of_Week[(RTC_Receive_Buf[6]&0b00000111)]); //day of week
            
        if(!status) 
        {  
        	LCD_Init();
        	LCD_Position(0,0);
        	LCD_PrCString("Fail!");  
        }
                           
    } 
}   
